-- #003 The Snake Game - Karim Jerbi(@apolius)

function love.load()
love.window.setTitle('The Snake Game')
window = {}
window.width = love.graphics.getWidth()
window.height = love.graphics.getHeight()

scl = 20

score = 0

snake = {}
snake.x = 0
snake.y = 0
snake.xspeed = 5
snake.yspeed = 0
snake.size = 0

tail = {}
function addtoTail()
	unit = {}
	unit.x = snake.x
	unit.y = snake.y
	unit.xspeed = snake.xspeed
	unit.yspeed = snake.yspeed
	table.insert(tail, snake.size,unit)
end
function updateTail() -- Thank you for the help, dear forums user ^-^
	if #tail > 0 then
		for i= #tail, 1, -1 do
			if i == #tail then
				tail[i].xspeed = snake.xspeed/5
				tail[i].yspeed = snake.yspeed/5
				tail[i].x = snake.x
				tail[i].y = snake.y
			else
				tail[i].xspeed = tail[i+1].xspeed/5
				tail[i].yspeed = tail[i+1].yspeed/5
				tail[i].x = tail[i+1].x
				tail[i].y = tail[i+1].y

			end
		end
	end
end

food = {}
food.x = love.math.random(scl,window.width-scl)
food.y = love.math.random(scl,window.height-scl)

function newFood()
	rgb = randomColor()
	food.x = love.math.random(scl,window.width-scl)
	food.y = love.math.random(scl,window.height-scl)
end

function eaten(b1,b2)
	local one = not((b1.x+scl < b2.x) or (b1.x > b2.x+scl))
	local two = not((b1.y+scl < b2.y) or (b1.y > b2.y+scl))
	return one and two
end

rgb = {0.1,0.5,0.1}
function randomColor()
	r = love.math.random(100/255,1)
	g = love.math.random(100/255,1)
	b = love.math.random(100/255,1)
	return {r,g,b}
end
end

function love.update()
-- drive system
if love.keyboard.isDown('up') and snake.yspeed~=5 then
	snake.xspeed = 0
	snake.yspeed = -5
elseif love.keyboard.isDown('down') and snake.yspeed~=-5 then
	snake.xspeed = 0
	snake.yspeed = 5
elseif love.keyboard.isDown('right') and snake.xspeed~=-5 then
	snake.xspeed = 5
	snake.yspeed = 0
elseif love.keyboard.isDown('left') and snake.xspeed~=5 then
	snake.xspeed = -5
	snake.yspeed = 0
end
if eaten(snake,food) then
	score = score +1
	snake.size = snake.size + 1
	addtoTail()
	newFood()
end

-- constrain & move the snake; update tail
if (snake.x + scl < window.width) and (snake.xspeed == 5) then
	snake.x = snake.x + snake.xspeed
end
if (snake.x > 0) and (snake.xspeed == -5) then
	snake.x = snake.x + snake.xspeed
end
if (snake.y + scl < window.height) and (snake.yspeed == 5)then
	snake.y = snake.y + snake.yspeed
end
if (snake.y > 0) and (snake.yspeed == -5) then
	snake.y = snake.y + snake.yspeed
end
updateTail()
end

function love.draw()
love.graphics.setColor(0, 1, 0.2)
love.graphics.rectangle('fill', snake.x, snake.y, scl, scl)
for i,unit in pairs(tail) do
love.graphics.rectangle('fill', unit.x, unit.y,scl,scl)
end
love.graphics.setColor(rgb)
love.graphics.rectangle('fill', food.x, food.y, scl, scl)
love.graphics.print(score)
love.graphics.print(#tail,50,0)
end